"""

BitcoinLights 0.1 by Marco Pontello, 2014

Just a super-simple Blockchain activity visualization demo to put a LIFX bulb to good use! :-)

Notes on code & libraries:

Started by modifying chainsnort by flatfly: https://github.com/flatfly/chainsnort
which use websocket-client module by liris: https://github.com/liris/websocket-client

LIFX support with an older version of the lifx-python library by sharph: https://github.com/sharph/lifx-python
I actually used the one included in LIFX-Menu by luwes: https://github.com/luwes/LIFX-Menu

For Python 2.x!

"""

import json, os, sys, datetime, time, urllib, websocket, operator, random
import lifx

sys.tracebacklimit = 0
t0 = time.time() ; Z = 0

print "BitcoinLights!\n"
print "Searching LIFX bulbs...",
lights = lifx.get_lights()
print "OK"
bulb = lights[0]
bulb.set_power(True)


def main():
    global Z
    hue = 0
    while True:
        result = ws.recv()
        time.sleep(0.05)
        result = json.loads(result)

        if result['op'] == 'block':
            continue

        inputs = sum(p['prev_out']['value'] for p in result['x']['inputs']  )
        outputs = sum(p['value'] for p in result['x']['out']  )
        feepaid = (inputs-outputs)/1e8
        val = sum(p['value'] for p in result['x']['out'])/1e8
        max_addr = sorted(result['x']['out'], key=operator.itemgetter('value'), reverse=True)[0]['addr']

        print datetime.datetime.utcnow().strftime("%H:%M:%S.%f")[:-3],
        print ' {:15.8f}'.format(val) ,'BTC '  + '' , max_addr 

        Z += 1

        hue = (hue + 60) % 360
        bulb.set_color(hue * 65536/360, 0xffff, 0xffff/2, 0, 0) # set color
        bulb.set_color(0, 0xffff, 0, 0, 10000) # fade to black


try:
    print 'Connecting to Blockchain.info...',
    domain='blockchain.info'
    stat = int(urllib.urlopen('https://'+domain+'/q/24hrtransactioncount').read().decode("utf8"))
    print 'OK'
    print '\b' + str(stat)  + '' +  ' new transactions in the last 24 hours  -  ' + ''  + '%02.02f' % (stat/86400.0) + '' + ' tx/sec'
    print 'Establishing TLS tunnel...',
    ws = websocket.create_connection("wss://ws."+domain+"/inv")
    ws.send('{"op":"unconfirmed_sub"}')  ;
    ws.send('{"op":"blocks_sub"}')
    print 'OK. Waiting for new transactions...\r'
    time.sleep(0.3)
    main()

except KeyboardInterrupt:
    t1 = time.time()
    print
    print "Closing threads..." , ' Captured',Z, 'events - Transaction density: %02.02f' % (Z/(t1 - t0)) , 'tx/sec'
    sys.exit()
